scala.tools.nsc.backend.icode.analysis.ReachingDefinitions

# rdefLattice

#### object rdefLattice extends SemiLattice

The lattice for reaching definitions. Elements are a triple (local variable, basic block, index of instruction of that basic block)

Linear Supertypes
SemiLattice, AnyRef, Any
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. rdefLattice
2. SemiLattice
3. AnyRef
4. Any

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Type Members

1. #### type Definition = (Global.icodes.Local, Global.icodes.BasicBlock, Int)

2. #### type Elem = IState[ListSet[(Global.icodes.Local, Global.icodes.BasicBlock, Int)], Stack]

   Definition Classes
     rdefLattice → SemiLattice

3. #### final case class IState [V, S](vars: V, stack: S) extends Product with Serializable

   Hold together local variable and stack state.

4. #### type Stack = collection.immutable.List[StackPos]

5. #### type StackPos = ListSet[(Global.icodes.BasicBlock, Int)]

### Value Members

1. #### final def !=(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

2. #### final def !=(arg0: Any): Boolean

   Definition Classes
     Any

3. #### final def ##(): Int

   Definition Classes
     AnyRef → Any

4. #### final def ==(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

5. #### final def ==(arg0: Any): Boolean

   Definition Classes
     Any

6. #### final def asInstanceOf[T0]: T0

   Definition Classes
     Any

7. #### val bottom: Elem

   Return the bottom element.

   Return the bottom element.

   Definition Classes
     rdefLattice → SemiLattice

8. #### def clone(): AnyRef

   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @throws( ... )

9. #### final def eq(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

10. #### def equals(arg0: Any): Boolean

    Definition Classes
      AnyRef → Any

11. #### def finalize(): Unit

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )

12. #### final def getClass(): Class[_]

    Definition Classes
      AnyRef → Any

13. #### def hashCode(): Int

    Definition Classes
      AnyRef → Any

14. #### final def isInstanceOf[T0]: Boolean

    Definition Classes
      Any

15. #### def lub(xs: List[Elem], exceptional: Boolean): Elem

    Compute the least upper bound of a list of elements.

    Compute the least upper bound of a list of elements.

    Definition Classes
      SemiLattice

16. #### def lub2(exceptional: Boolean)(a: Elem, b: Elem): Elem

    The least upper bound is set inclusion for locals, and pairwise set inclusion for stacks.

    The least upper bound is set inclusion for locals, and pairwise set inclusion for stacks.

    Definition Classes
      rdefLattice → SemiLattice

17. #### final def ne(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

18. #### final def notify(): Unit

    Definition Classes
      AnyRef

19. #### final def notifyAll(): Unit

    Definition Classes
      AnyRef

20. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

21. #### def toString(): String

    Definition Classes
      AnyRef → Any

22. #### val top: Elem

    Return the top element.

    Return the top element.

    Definition Classes
      rdefLattice → SemiLattice

23. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

24. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

25. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

### Inherited from SemiLattice

### Inherited from AnyRef

### Inherited from Any

### Ungrouped